# coding: utf-8
import sys
import matplotlib.pyplot as plt
from scipy import ndimage
path = sys.argv[1]
print("I am reading {}".format(path))
img = ndimage.imread(path)
print("I have read")
img_gray = 0.21 * img[:,:,0] + 0.72 * img[:,:,1] + 0.07 * img[:,:,2]
# plt.imshow(img_gray, cmap="Greys_r")
# plt.show()
from sklearn.cluster import KMeans
k = KMeans(n_clusters=5)
img_reshaped = img_gray.reshape((-1,1))
k.fit(img_reshaped)
values = k.cluster_centers_.squeeze()
labels = k.labels_
# labels
img_labels = labels.reshape(img_gray.shape)
# img_labels
# plt.imshow(img_labels)
# plt.show()
# get_ipython().magic(u'pinfo ndimage.median_filter')
# get_ipython().magic(u'pinfo ndimage.median_filter')
# get_ipython().magic(u'pinfo ndimage.median_filter')
img_labels2 = ndimage.median_filter(img_labels, 3)
# plt.imshow(img_labels2)
# plt.show()
from skimage.feature import corner_harris, corner_subpix, corner_peaks
coords = corner_peaks(corner_harris(img_labels2), min_distance=5)
coords_subpix = corner_subpix(img_labels2, coords, window_size=13)
fig, ax = plt.subplots()
ax.imshow(img_labels2, interpolation='nearest', cmap=plt.cm.gray)
ax.plot(coords[:, 1], coords[:, 0], '.b', markersize=3)
ax.plot(coords_subpix[:, 1], coords_subpix[:, 0], '+r', markersize=15)
# ax.axis((0, 350, 350, 0))
plt.show()
# fig, ax = plt.subplots()
# ax.imshow(img_labels2, interpolation='nearest', cmap=plt.cm.gray)
# ax.plot(coords[:, 1], coords[:, 0], '.b', markersize=3)
# ax.plot(coords_subpix[:, 1], coords_subpix[:, 0], '+r', markersize=15)
# plt.show()
# get_ipython().magic(u'save poi_shoe_detection.py 1-39')
